/*
 *	FixMath.h Glue Functions ...
 */

#if __MC68881__

#ifndef __FIXMATH__
#include <FixMath.h>
#endif

#ifndef __SANE__
#include <SANE.h>
#endif

#ifndef __TRAPS__
#include <Traps.h>
#endif

/*
 *	SANE 10byte doubles code ...
 */

static pascal extended80 __Frac2X(Fract x) = {_Frac2X};
static pascal extended80 __Fix2X(Fixed x) = {_Fix2X};
static pascal Fixed __X2Fix(extended80 x) = {_X2Fix};
static pascal Fract __X2Frac(extended80 x) = {_X2Frac};

/*
 *	SANE 10byte doubles code ...
 */

pascal double_t Frac2X(Fract x)
{
	extended96 xtd96;
	extended80 xtd80 = __Frac2X(x);

	x80tox96(&xtd80, &xtd96);
	return xtd96;
}

pascal double_t Fix2X(Fixed x)
{
	extended96 xtd96;
	extended80 xtd80 = __Fix2X(x);
	
	x80tox96(&xtd80, &xtd96);
	return xtd96;
}

pascal Fixed X2Fix(double_t xtd96)
{
	extended80 xtd80;
	
	x96tox80(&xtd96, &xtd80);
	return (__X2Fix(xtd80));
}

pascal Fract X2Frac(double_t xtd96)
{
	extended80 xtd80;
	
	x96tox80(&xtd96, &xtd80);
	return (__X2Frac(xtd80));
}

#endif
