
/*
 *	Startup.c		-	Default init/startup/termination routines for Metrowerks C++ (PowerPC)
 *
 *	Copyright  1993 metrowerks inc. All Rights Reserved.
 *
 */

#include <CPlusLibPPC.h>
#include <Quickdraw.h>
#include <SegLoad.h>
#include <setjmp.h>


	/*	public data		*/

QDGlobals qd;						/*	define the Quickdraw globals here!	*/
jmp_buf __program_exit;				/*	exit() does a longjmp() to here		*/
void (*__atexit_hook)(void);		/*	atexit()  sets this up if it is ever called	*/
void (*___atexit_hook)(void);		/*	_atexit() sets this up if it is ever called	*/
int __aborting;						/*	abort() sets this and longjmps to __program_exit	*/


 	/*	external references	*/

extern int main(long argc, char **argv, char **envp);


	/*	prototypes	*/

void __sinit(void);
int __start(void);


/*
 *	__sinit		-	stub for static initialization of C++ objects
 *
 *	The linker replaces the contents of this module with something of the form:
 *
 *			mflr	r0
 *			stw		r0,8(sp)
 *			stwu	sp,-64(sp)
 *			bl		__sinit_<file1>
 *			bl		__sinit_<file2>
 *			...
 *			bl		__sinit_<fileN>
 *			addi	sp,sp,64
 *			lwz		r0,8(sp)
 *			mtlr	r0
 *			blr
 */

void __sinit(void)
{
}


/*
 *	__start	-	Default startup routine for Metrowerks C++ (PowerPC)
 *
 *	This routine should be specified as the PEF main routine in the container
 *	for any application. The program startup/termination sequence is:
 *
 *	1.	Set up a jmp_buf for exit() to jump to
 *	2.	Call all static initializers--these might call exit()
 *	3.	Set up default values for 'argc' and 'argv' and call main()
 *	4.	Execute any atexit() routines
 *	5.	Destroy all static objects
 *	6.	Execute any cleanup code, e.g. close open files, console window, etc.
 *	7.	Terminate the Macintosh program
 *
 *	We postulate that there are 2 kinds of atexit() routines: those which must
 *	execute before any  objects are destroyed, and those which must execute after.
 *	We assume there is a non-standard _atexit() routine which can be used to install
 *	the post-destruction exit handlers.
 *
 */

int __start(void)
{
	extern	int		__NubAt3;
	extern	void	_BreakPoint(void);
	extern	int		__C_phase;
	extern	int		_exit_status;
	extern	jmp_buf	__target_for_exit;
	extern	struct {
				short	unknown;
				long	ArgC;
				char	**ArgV;
				char	**EnvP;
			} _IntEnv;
		
	int		ret = 0;
	char *argv = 0;
	
	if (__NubAt3 != 0) {
		_BreakPoint();
	}
	
	__C_phase = 2;
	
	if (setjmp(__target_for_exit) == 0) {	//	set up jmp_buf for exit()
		__sinit();						//	call all static initializers
		_exit_status = main(_IntEnv.ArgC, _IntEnv.ArgV, _IntEnv.EnvP);
		__destroy_global_chain();
		exit(_exit_status);				// this will jump to setjmp following the atexit_hook()
	}
	return(_exit_status);
}
